/*******************************************************************************/
/* Car Alarm System                                                            */
/*******************************************************************************/
/* as described in                                                             */
/*     http://www.mogentes.eu/public/deliverables/
                MOGENTES_3-15_1.0r_D3.4b_TestTheories-final_main.pdf           */
/*******************************************************************************/

#define TIMEOUT1 4 //4 //400
#define TIMEOUT2 5 //5 //600
#define TIMEOUT3 10 //10 //5400

#include "Alarm_system.c"
#include "cas_alarm_f.c"

#ifndef NO_CBMC

void state_assume(t_cas_alarm_f_state *_state_) {
  __CPROVER_assume((!_state_->Alarm_system_state.Alarm_system_OPEN &&
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN
		   )
                    ||
                   (
                   _state_->Alarm_system_state.Alarm_system_OPEN 
                   &&
                   (_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                ||
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   _state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                ||
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   _state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                   &&
		   (
		    (_state_->Alarm_system_data.Counter == 1) &&
                   _state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterEnd_OPEN ||

                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterStart_OPEN &&
                   _state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterEnd_OPEN ||

		    (_state_->Alarm_system_data.Counter == 0) &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterPlus_OPEN &&
                   _state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterEnd_OPEN
		    )
                ||
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   _state_->Alarm_system_state.AlarmArmed_OPEN &&
		    (_state_->Alarm_system_data.Counter == 0) &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                ||
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   _state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                   &&
		   (
		    (_state_->Alarm_system_data.Counter == 1) &&
                   _state_->Alarm_system_state.AlarmAcousticAndOptical_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN ||

                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterStart_OPEN &&
                   _state_->Alarm_system_state.AlarmAcousticAndOptical_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN ||

		    (_state_->Alarm_system_data.Counter == 0) &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_CounterPlus_OPEN &&
                   _state_->Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN 
		   ) 
                ||
                   !_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN &&
                   !_state_->Alarm_system_state.AlarmArmed_OPEN &&
                   !_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN &&
                   _state_->Alarm_system_state.AlarmOnlyOptical_OPEN 
                   &&
		   (
                   _state_->Alarm_system_state.AlarmOnlyOptical_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN ||

                   (_state_->Alarm_system_data.Counter == 1) &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterPlus_OPEN &&
                   _state_->Alarm_system_state.AlarmOnlyOptical_CounterStart_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN ||

                   (_state_->Alarm_system_data.Counter == 0) &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterPlus_OPEN &&
                   !_state_->Alarm_system_state.AlarmOnlyOptical_CounterStart_OPEN &&
                   _state_->Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN
		    )
		    )) 
                  );
}

void input_assume(t_cas_alarm_f_io *_io_) {
  __CPROVER_assume((0<=_io_->In1) && (_io_->In1<=1) && // VehLocked
                   (0<=_io_->In2) && (_io_->In2<=1));  // AlarmSensor
}

extern t_cas_alarm_f_io nondet_io();

void final(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  __CPROVER_assume(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop1(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(!_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_state_->Alarm_system_state.VehicleOpen_OPEN &&
                   !_io_->In1 && !_io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop2(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(
		   (_state_->Alarm_system_state.AlarmArmed_OPEN ||
		    _state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN ||
                    _state_->Alarm_system_state.AlarmOnlyOptical_OPEN)
                  && !_io_->In1 && !_io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop3(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmArmed_OPEN && 
                   _io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN);
}

void prop4(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN && 
                   _state_->Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN && _io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN);
}

void prop5(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN && 
                   _state_->Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN && _io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmArmed_OPEN);
}

void prop6(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN && !_io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop7(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN && !_io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop8(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.VehicleOpen_OPEN && !_io_->In1 && _io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop9(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN && _io_->In1 && _io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN);
}

void prop10(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN && _io_->In1 && _io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN);
}

void prop11(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN && _io_->In1 && _io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN);
}

void prop12(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmArmed_OPEN && _io_->In1 && !_io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmArmed_OPEN);
}

void prop13(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmArmed_OPEN && !_io_->In1 && !_io_->In2);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop14(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmAcousticAndOptical_OPEN && !_io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop15(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.AlarmOnlyOptical_OPEN && !_io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop16(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.InitSystem_OPEN && 
                   !_io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.VehicleOpen_OPEN);
}

void prop17(t_cas_alarm_f_io *_io_, t_cas_alarm_f_state *_state_) {
  //precondition
  input_assume(_io_);
  __CPROVER_assume(_state_->Alarm_system_state.InitSystem_OPEN && 
                   _io_->In1);
  //step
  cas_alarm_f_compute(_io_,_state_);
  //postcondition
  assert(_state_->Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN);
}

void main() { }

#endif

/*
int main() {
  int k=0;
  t_cas_alarm_f_state _state_; 
  cas_alarm_f_init(&_state_);
  while(k<=30) {
    t_cas_alarm_f_io _io_ = {1,0};
    switch(k) {
    case 8: _io_.In2 = 1; break;
    case 9: _io_.In2 = 0; break;
    }
    printf("k =%d\n",k);
    printf("s = { Counter=%d\n      Alarm_system=%d\n      InitSystem=%d\n      VehicleOpen=%d\n      AlarmWillBeArmedAfter20sec=%d\n      AlarmWillBeArmedAfter20sec_CounterStart=%d\n      AlarmWillBeArmedAfter20sec_CounterPlus=%d\n      AlarmWillBeArmedAfter20sec_CounterEnd=%d\n      AlarmArmed=%d\n      AlarmAcousticAndOptical=%d\n      AlarmAcousticAndOptical_CounterStart=%d\n      AlarmAcousticAndOptical_CounterPlus=%d\n      AlarmAcousticAndOptical_CounterEnd=%d\n      AlarmOnlyOptical=%d\n      AlarmOnlyOptical_CounterStart=%d\n      AlarmOnlyOptical_CounterPlus=%d\n      AlarmOnlyOptical_CounterEnd=%d }\n",
  _state_.Alarm_system_data.Counter
  ,_state_.Alarm_system_state.Alarm_system_OPEN
  ,_state_.Alarm_system_state.InitSystem_OPEN
  ,_state_.Alarm_system_state.VehicleOpen_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmWillBeArmedAfter20sec_CounterEnd_OPEN
  ,_state_.Alarm_system_state.AlarmArmed_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmAcousticAndOptical_CounterEnd_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterStart_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterPlus_OPEN
  ,_state_.Alarm_system_state.AlarmOnlyOptical_CounterEnd_OPEN);
    state_assert(&_state_);
   printf("i = {%d%d}\n",_io_.In1,_io_.In2);
    cas_alarm_f_compute(&_io_,&_state_);
    k++;
  }
  return 0;
}
*/
